darcs-2.8.4: a distributed, interactive, smart revision control system

Safe Haskell | None

Darcs.Patch.Invert

# Documentation

class Invert p where

Methods

invert :: p x y -> p y x

Instances

Invert Prim |
Invert Prim |
Invert DummyPatch |
(Commute p, Invert p) => Invert (RL p) |
(Invert p, Commute p) => Invert (FL p) |
Invert prim => Invert (Patch prim) |
(Commute p, Invert p) => Invert (Named p) |
(Commute p, Invert p) => Invert (PatchInfoAnd p) |
Invert p => Invert (TaggedPatch p) |
Invert prim => Invert (RealPatch prim) |

invertFL :: Invert p => FL p x y -> RL p y x

invertRL :: Invert p => RL p x y -> FL p y x